﻿namespace ClassesVersusStructs {
	class C {
		public int X;
	}

	struct S {
		public int Y;
	}

	class Program {
		static void Main(string[] args) {
			C c1 = new C();
			c1.X = 10;
			S s1 = new S();
			s1.Y = 100;
			Console.WriteLine("Main: c1.x == {0}, s1.y == {1}", c1.X, s1.Y);
			f(c1, s1);
			Console.WriteLine("Main: c1.x == {0}, s1.y == {1}", c1.X, s1.Y);

			Console.WriteLine();
			Console.WriteLine(c1);
			Console.WriteLine(s1);
		}

		static void f(C c2, S s2) {
			Console.WriteLine(" f:   c2.x == {0}, s2.y == {1}", c2.X, s2.Y);
			c2.X = 20;
			s2.Y = 200;
			Console.WriteLine(" f:   c2.x == {0}, s2.y == {1}", c2.X, s2.Y);
			g(c2, s2);
			Console.WriteLine(" f:   c2.x == {0}, s2.y == {1}", c2.X, s2.Y);
		}

		static void g(C c3, S s3) {
			Console.WriteLine("  g:  c3.x == {0}, s3.y == {1}", c3.X, s3.Y);
			c3.X = 30;
			s3.Y = 300;
			Console.WriteLine("  g:  c3.x == {0}, s3.y == {1}", c3.X, s3.Y);
		}
	}
}
